#ifndef RFMCONFIG_H
#define RFMCONFIG_H

#define HARDWARE_SPI

#ifndef HARDWARE_SPI

#define SCK_DDR DDRB
#define SCK_PORT PORTB
#define SCK_BIT 7   // SPI clock

#define SDO_DDR DDRB
#define SDO_PIN PINB
#define SDO_BIT 6   // SPI Data output (RFM12B side)

#define SDI_DDR DDRB
#define SDI_PORT PORTB
#define SDI_BIT 5   // SPI Data input (RFM12B side)

#define CS_DDR DDRB
#define CS_PORT PORTB
#define CS_BIT  4   // SPI SS (chip select)

#else

#define DDR_SPI	DDRB
#define PORT_SPI PORTB
#define DD_MOSI 5
#define DD_SCK 7
#define DD_SS  4

#endif

#define NIRQ_DDR DDRD
#define NIRQ_PIN PIND
#define NIRQ_BIT 2  // (PORTD)


#define THERM_DQ PA2
#define THERM_DDR DDRA
#define THERM_PORT PORTA
#define THERM_PIN PINA



#define WAIT_NIRQ_LOW() (NIRQ_PIN&(1<<NIRQ_BIT))

#endif
